"use client";

// src/QrCodeScanner.tsx
import { BrowserMultiFormatReader, Exception as Exp } from "@zxing/library";
import { useEffect, useRef } from "react";
import { parse } from "superjson";
import React from "react";
function QrCodeScanner(props) {
  const videoRef = useRef(null);
  const reader = useRef(new BrowserMultiFormatReader());
  useEffect(() => {
    if (!videoRef.current)
      return;
    reader.current.decodeFromConstraints(
      {
        audio: false,
        video: {
          facingMode: props.facingMode || "environment"
        }
      },
      videoRef.current,
      (result, error) => {
        if (result) {
          const data = () => {
            try {
              let data2;
              try {
                data2 = parse(result.getText());
              } catch (error2) {
                return props.validate ? props.validate(result.getText()) : result.getText();
              }
              return props.validate ? props.validate(data2) : data2;
            } catch (error2) {
              if (error2 && error2 != null && error2 != void 0 && typeof error2.message == "string")
                throw new Exp(error2.message);
              throw new Exp("Unknown error");
            }
          };
          props.onResult(data(), result);
        }
        if (error && props.onError != null && // not found error is not an error
        error.getKind() !== "NotFoundException")
          props.onError(error);
      }
    );
    return () => {
      reader.current.reset();
    };
  }, [videoRef]);
  return /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement("video", { ref: videoRef }));
}
export {
  QrCodeScanner
};
